# -*- coding: UTF-8 -*-

from zope.interface import implements

from Products.Five.browser.pagetemplatefile import ZopeTwoPageTemplateFile

from Products.CMFPlone.i18nl10n import utranslate

from Products.statusmessages import STATUSMESSAGEKEY
from Products.statusmessages.adapter import _decodeCookieValue

from kss.core import AzaxBaseView as base
from kss.core import force_unicode

from interfaces import IPloneAzaxView

class AzaxBaseView(base):
    '''The base view that contains helpers, to be imported
    be other plone products
    '''

    implements(IPloneAzaxView)
    
    header_macros = ZopeTwoPageTemplateFile('browser/macro_wrapper.pt')

    def macroContent(self, macropath, **kw):
        'Renders a macro and returns its text'
        path = macropath.split('/')
        if len(path) < 2 or path[-2] != 'macros':
            raise RuntimeError, 'Path must end with macros/name_of_macro (%s)' % (repr(macropath), )
        # needs string, do not tolerate unicode (causes but at traverse)
        jointpath = '/'.join(path[:-2]).encode('ascii')
        macroobj = self.context.restrictedTraverse(jointpath)
        try:
            the_macro = macroobj.macros[path[-1]]
        except AttributeError, IndexError:
            raise RuntimeError, 'Macro not found'
        #  
        # put parameters on the request, by saving the original context
        self.request.form, orig_form = kw, self.request.form
        content = self.header_macros(the_macro=the_macro)
        self.request.form = orig_form
        # Always encoded as utf-8
        content = force_unicode(content, 'utf')
        return content

    def translateMessage(self, message):
        return utranslate(None, message, context=self.context)

    def issueAllPortalMessages(self):
        if hasattr(self.request.RESPONSE, 'cookies'):
            cookie = self.request.RESPONSE.cookies.get(STATUSMESSAGEKEY)
            if cookie:
                encodedstatusmessages = cookie['value']
                statusmessages = _decodeCookieValue(encodedstatusmessages)
            else:
                statusmessages = []
            for msg in statusmessages:
                self.getCommandSet('portalmessage').issuePortalMessage(msg.message)
                self.request.RESPONSE.expireCookie(STATUSMESSAGEKEY, path='/')
